package task2;

import java.util.Date;

public class CEO extends Person {

    private Organization organization;

    // Constructor for the CEO class.
    // Receives the name, sex, birth date, and Organization
    // which the CEO operates.

    public CEO(String n, String s, Date d, Organization organization) {
        super(n, s, d);
        this.organization = organization;
    }

    // Returns the String representation of the Organization for which the
    // CEO works, if any.
    public Organization getOrganization() {
        return organization;
    }

    // Returns true if this CEO object is equal to other.
    // Two CEOs are equal if they have the same name, sex, birthdate,
    // and organization.
    public boolean equals(Object other) {
        return super.equals(other) &&
                ((CEO) other).organization.equals(organization);
    }

    // Returns a string representation of the CEO that contains all of
    // their professional and personal attributes.
    public String toString() {
        return super.toString() + ", Organization: " + organization.toString();
    }

    // Removes the given Employee from the organization.
    public void fire(Employee e) {
        organization.removeEmployee(e);
    }

    // Associates the given Employee with the CEO's organization.
    public void hire(Employee e) {
        organization.addEmployee(e);
    }
}
