package task2;

import java.util.ArrayList;
import java.util.List;

public class Organization {

    private String name;
    private List<Employee> employees;

    public Organization(String name) {
        this.name = name;
        employees = new ArrayList<>();
    }

    public String getName() {
        return name;
    }

    public int getNumberOfEmployees() {
        return employees.size();
    }

    // Adds an employee to this organization.
    public void addEmployee(Employee e)	{
        employees.add(e);
    }

    // Removes an employee from this organization.
    public void removeEmployee(Employee e)	{
        employees.remove(e);
    }

    // Returns true if this Organization object is equal to other.
    // Two organizations are equal if they have the same name and
    // the same Employees.
    public boolean equals(Object other) {
        return other instanceof Organization &&
                ((Organization) other).name.equals(name) &&
                sameEmployees((Organization) other);
    }

    private boolean sameEmployees(Organization other) {
        return employees.containsAll(other.employees) &&
                other.employees.containsAll(employees);
    }

    // Returns a String representation of the Organization.
    public String toString() {
        return "Name: " + name + ", Employees: " + employees.toString();
    }
}